Imports System.Math
Imports System.IO

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents dlgNet As System.Windows.Forms.OpenFileDialog
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents mnuFile As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.dlgNet = New System.Windows.Forms.OpenFileDialog
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.mnuFile = New System.Windows.Forms.MenuItem
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem
        '
        'dlgNet
        '
        Me.dlgNet.DefaultExt = "net"
        Me.dlgNet.Filter = "Net Files (*.net)|*.net|All Files|*.*"
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFile})
        '
        'mnuFile
        '
        Me.mnuFile.Index = 0
        Me.mnuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileOpen})
        Me.mnuFile.Text = "&File"
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 0
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "PathS[]"

    End Sub

#End Region

    Private m_Nodes As Collection
    Private m_Links As Collection
    Private m_Root As PathSNode
    Private m_GotPathTree As Boolean = False
    Private m_Destination As PathSNode

    Private Const RADIUS As Single = 10
    Private Const RADIUS_SQUARED As Single = RADIUS * RADIUS

    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        If dlgNet.ShowDialog() = DialogResult.Cancel Then Exit Sub
        Dim status As Long

        LoadNetwork(dlgNet.FileName)

        ' Display the network.
        Me.Invalidate()
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        DrawNetwork(e.Graphics)
    End Sub

    ' Display the network.
    Private Sub DrawNetwork(ByVal gr As Graphics)
        gr.Clear(Me.BackColor)
        If m_Nodes Is Nothing Then Exit Sub

        ' Draw the links.
        Dim tree_pen As New Pen(Color.Blue, 3)
        Dim path_pen As New Pen(Color.Red, 3)
        Dim link_pen As Pen
        Dim bg_brush As New SolidBrush(Me.BackColor)
        For Each link As PathSLink In m_Links
            If link.LinkUsage = PathSLink.LinkUseageType.InTree Then
                link_pen = tree_pen
            ElseIf link.LinkUsage = PathSLink.LinkUseageType.InPath Then
                link_pen = path_pen
            Else
                link_pen = Pens.Black
            End If

            Dim x1 As Single = link.Node1.X
            Dim y1 As Single = link.Node1.Y
            Dim x2 As Single = link.Node2.X
            Dim y2 As Single = link.Node2.Y
            Dim dx As Single = x2 - x1
            Dim dy As Single = y2 - y1
            Dim dist As Single = CSng(Sqrt(dx * dx + dy * dy))
            If dist > 0 Then
                dx = dx * RADIUS / dist
                dy = dy * RADIUS / dist

                ' Draw the link.
                x1 = x1 + dx
                y1 = y1 + dy
                x2 = x2 - dx
                y2 = y2 - dy
                gr.DrawLine(link_pen, x1, y1, x2, y2)

                ' Draw the link cost.
                x1 = (x1 + x2) / 2
                y1 = (y1 + y2) / 2
                gr.FillEllipse(bg_brush, _
                    x1 - RADIUS, y1 - RADIUS, _
                    2 * RADIUS, 2 * RADIUS)
                Dim txt As String = link.Cost.ToString()
                Dim txt_size As SizeF = gr.MeasureString(txt, Me.Font)
                gr.DrawString(txt, Me.Font, Brushes.Black, _
                    x1 - txt_size.Width / 2, _
                    y1 - txt_size.Height / 2)
            End If
        Next link

        ' Draw the nodes.
        Dim text_brush As Brush
        Dim node_brush As Brush
        Dim node_pen As Pen
        For Each node As PathSNode In m_Nodes
            ' Draw the node and its links.
            If (node Is m_Root) Or (node Is m_Destination) Then
                ' Highlight the node.
                text_brush = Brushes.White
                node_brush = Brushes.Black
                node_pen = Pens.White
            Else
                ' Do not highlight the node.
                text_brush = Brushes.Black
                node_brush = Brushes.White
                node_pen = Pens.Black
            End If

            ' Draw the node.
            gr.FillEllipse(node_brush, _
                node.X - RADIUS, node.Y - RADIUS, _
                2 * RADIUS, 2 * RADIUS)
            gr.DrawEllipse(node_pen, _
                node.X - RADIUS, node.Y - RADIUS, _
                2 * RADIUS, 2 * RADIUS)
            Dim txt As String = node.Id.ToString()
            Dim txt_size As SizeF = gr.MeasureString(txt, Me.Font)
            gr.DrawString(txt, Me.Font, text_brush, _
                node.X - txt_size.Width / 2, _
                node.Y - txt_size.Height / 2)
        Next node
        tree_pen.Dispose()
        path_pen.Dispose()
        bg_brush.Dispose()
    End Sub

    ' Load the network data from a file with format:
    '   # Nodes, # Links
    '   For each node: Id, X, Y
    '   For each link: Node1, Node2, Cost
    Private Sub LoadNetwork(ByVal fname As String)
        ' Open the file.
        Try
            Dim xmax As Single
            Dim ymax As Single

            ' Open the file.
            Dim fnum As Integer = FreeFile()
            FileOpen(fnum, fname, OpenMode.Input, OpenAccess.Read, OpenShare.Shared)

            ' Read the number of nodes and links.
            Dim num_nodes As Integer
            Dim num_links As Integer
            Input(fnum, num_nodes)
            Input(fnum, num_links)

            ' Read the node identifiers and coordinates.
            m_Nodes = New Collection
            For i As Integer = 1 To num_nodes
                Dim new_node As New PathSNode
                With new_node
                    Input(fnum, .Id)
                    Input(fnum, .X)
                    Input(fnum, .Y)

                    If xmax < .X Then xmax = .X
                    If ymax < .Y Then ymax = .Y
                End With
                m_Nodes.Add(new_node, new_node.Id.ToString())
            Next i

            ' Read the links.
            m_Links = New Collection
            For i As Integer = 1 To num_links
                Dim new_link As New PathSLink
                With new_link
                    ' Get the node IDs.
                    Dim node1_num As Integer
                    Dim node2_num As Integer
                    Input(fnum, node1_num)
                    Input(fnum, node2_num)

                    ' Find the nodes.
                    .Node1 = DirectCast(m_Nodes(node1_num.ToString()), PathSNode)
                    .Node2 = DirectCast(m_Nodes(node2_num.ToString()), PathSNode)
                    m_Links.Add(new_link, node1_num.ToString() & "-" & node2_num.ToString())

                    ' Get the cost.
                    Input(fnum, .Cost)

                    ' Add the link to the nodes' Links collections.
                    .Node1.Links.Add(new_link, node2_num.ToString())
                    .Node2.Links.Add(new_link, node1_num.ToString())
                End With
            Next i

            ' Close the file.
            FileClose(fnum)

            ' Size the form to fit.
            Dim new_rect As Rectangle = Rectangle.Union( _
                Me.ClientRectangle, _
                New Rectangle(0, 0, CInt(xmax + RADIUS + 10), CInt(ymax + RADIUS + 10)))
            Me.ClientSize = New Size(new_rect.Width, new_rect.Height)
        Catch ex As Exception
            MessageBox.Show("Error reading network file." & vbCrLf & ex.Message, _
                "File Error", _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Exclamation)
        End Try

        Me.Text = "PathS[" & fname.Substring(fname.LastIndexOf("\") + 1) & "]"
    End Sub

    ' Select the path tree's root node.
    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        If m_Nodes Is Nothing Then Exit Sub

        ' Find the node at this point.
        Dim node_at As PathSNode = NodeAt(e.X, e.Y)
        If node_at Is Nothing Then Exit Sub

        If e.Button = MouseButtons.Left Then
            ' Find the shortest path tree rooted at this node.
            FindPathTree(node_at)
        Else
            ' Set this node as the destination.
            m_Destination = node_at
            FindShortestPath()
        End If
    End Sub

    ' Find the node at this point.
    Private Function NodeAt(ByVal X As Integer, ByVal Y As Integer) As PathSNode
        For Each node As PathSNode In m_Nodes
            Dim dx As Single = node.X - X
            Dim dy As Single = node.Y - Y
            If dx * dx + dy * dy <= RADIUS_SQUARED Then Return node
        Next node

        Return Nothing
    End Function

    ' Find a shortest path tree rooted at this node
    ' using a label setting algorithm.
    Private Sub FindPathTree(ByVal root As PathSNode)
        Dim candidates As New Collection

        If root Is Nothing Then Exit Sub
        m_Root = root

        ' Reset all nodes' Marked and NodeStatus values,
        ' and all links' Used and LinkUsage flags.
        ResetPathTree()

        ' Start with the root in the shortest path tree.
        root.Dist = 0
        root.InLink = Nothing
        root.NodeStatus = PathSNode.NodeStatusType.NowInList
        candidates.Add(root)

        ' Process the candidates.
        Do While candidates.Count > 0
            ' Find the candidate closest to the root.
            Dim best_dist As Integer = Integer.MaxValue
            Dim best_i As Integer = 0
            For i As Integer = 1 To candidates.Count
                Dim candidate_node As PathSNode = DirectCast(candidates(i), PathSNode)
                Dim new_dist As Integer = candidate_node.Dist
                If new_dist < best_dist Then
                    best_i = i
                    best_dist = new_dist
                End If
            Next i

            ' Add this node to the shortest path tree.
            Dim node As PathSNode = DirectCast(candidates(best_i), PathSNode)
            candidates.Remove(best_i)
            node.NodeStatus = PathSNode.NodeStatusType.WasInList

            ' Examine the node's neighbors.
            For Each link As PathSLink In node.Links
                Dim to_node As PathSNode
                If node Is link.Node1 Then
                    to_node = link.Node2
                Else
                    to_node = link.Node1
                End If
                If to_node.NodeStatus = PathSNode.NodeStatusType.NotInList Then
                    ' The node has not been in the candidate list. Add it.
                    candidates.Add(to_node)
                    to_node.NodeStatus = PathSNode.NodeStatusType.NowInList
                    to_node.Dist = best_dist + link.Cost
                    to_node.InLink = link
                ElseIf to_node.NodeStatus = PathSNode.NodeStatusType.NowInList Then
                    ' The node is in the candidate list.
                    ' Update its Dist and inlink values if necessary.
                    Dim new_dist As Integer = best_dist + link.Cost
                    If new_dist < to_node.Dist Then
                        to_node.Dist = new_dist
                        to_node.InLink = link
                    End If
                End If
            Next link
        Loop

        m_GotPathTree = True

        ' Mark the inlinks so they are easy to draw.
        For Each node As PathSNode In m_Nodes
            If Not (node.InLink Is Nothing) Then node.InLink.LinkUsage = PathSLink.LinkUseageType.InTree
        Next node

        ' Start with no destination.
        m_Destination = Nothing

        ' Redraw the network.
        Me.Invalidate()
    End Sub

    ' Remove all links from the shortest path tree.
    Private Sub ResetPathTree()
        ' Don't bother if there's no shortest path tree.
        If Not m_GotPathTree Then Exit Sub

        For Each node As PathSNode In m_Nodes
            node.NodeStatus = PathSNode.NodeStatusType.NotInList
        Next node

        For Each link As PathSLink In m_Links
            link.LinkUsage = PathSLink.LinkUseageType.Unused
        Next link

        m_GotPathTree = False
    End Sub

    ' Find the shortest path from the destination to the root.
    Private Sub FindShortestPath()
        ' Reset any links that were in the previous shortest path.
        For Each link As PathSLink In m_Links
            If link.LinkUsage = PathSLink.LinkUseageType.InPath Then
                link.LinkUsage = PathSLink.LinkUseageType.InTree
            End If
        Next link

        ' Trace the path from the destination to the root.
        Dim node As PathSNode = m_Destination
        Do Until node Is m_Root
            node.InLink.LinkUsage = PathSLink.LinkUseageType.InPath
            If node.InLink.Node1 Is node Then
                node = node.InLink.Node2
            Else
                node = node.InLink.Node1
            End If
        Loop

        ' Redraw the network.
        Me.Invalidate()
    End Sub
End Class
